import java.io.*;
import java.util.*;

public class Solver {
//    static class Sklad {
//        static int id;
//        static int maxH;
//        public Sklad(int id, int maxH) {
//            Sklad.id = id;
//            Sklad.maxH = maxH;
//        }
//    }
    static class Road {
        public int n1;
        public int n2;
        public Road(int n1, int n2) {
            this.n1 = n1;
            this.n2 = n2;
        }
    }

    static int getDist(int i, int prev, int target, Road[] roads, int dist, HashSet<Integer> mem) {
        if (i == target) {
            return dist;
        } else if (mem.contains(i)) {
            return -1;
        }

        int min = Integer.MAX_VALUE;
        for (Road r:roads) {
            int v1 = 0;
            int v2 = 0;
            HashSet<Integer> copy = new HashSet<>(mem);
            copy.add(i);
            if (r.n1 == i && r.n2 != prev) {
                v1 = Math.min(getDist(r.n2, i, target, roads, dist+1, copy), min);
                if (v1 != -1) {
                    min = Math.min(v1, min);
                }
            }
            if (r.n2 == i && r.n1 != prev) {
                v2 = Math.min(getDist(r.n1, i, target, roads, dist+1, copy), min);
                if (v2 != -1) {
                    min = Math.min(v2, min);
                }
            }
        }

        return min;
    }


    public static void main(String[] args) throws IOException {
        int n =nextInt();
        int m = nextInt();
        int k = nextInt();

        Road[] roads = new Road[m];
        for (int i = 0; i < m; i++) {
            roads[i] = new Road(nextInt(), nextInt());
        }
        HashMap<Integer, Integer> map = new HashMap<>();
        for (int i = 0; i < k; i++) {
            int id = nextInt();
            map.put(id, Math.max(map.getOrDefault(id,0), nextInt()));
        }

        HashMap<String, Integer> dist = new HashMap<>();
        boolean[] safe = new boolean[n];
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= n; j++) {
                if (i == j ) continue;
                int res = getDist(i, -1, j, roads, 0, new HashSet<>());
                dist.put(i + " " + j, res);
                dist.put(j + " " + i, res);

                if (res <= map.getOrDefault(i, Integer.MIN_VALUE)) {
                    safe[j-1] = true;
                }
                if (map.getOrDefault(i, Integer.MIN_VALUE) > 0) {
                    safe[i-1] =true;
                }
            }
        }

        int cnt = 0;
        StringBuilder res = new StringBuilder();
        for (int i = 0; i < n; i++) {
            if (safe[i]) {
                res.append((i + 1)).append(" ");
                cnt++;
            }
        }
        out.println(cnt);
        out.println(res);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}